diff --git a/src/vtp_fmt_plug.c b/src/vtp_fmt_plug.c
index 5e691597ad..0b32abdeba 100644
--- a/src/vtp_fmt_plug.c
+++ b/src/vtp_fmt_plug.c
@@ -88,7 +88,7 @@ static  struct custom_salt {
 	unsigned char salt[2048];
 	int trailer_length;
 	int version;
-	unsigned char *trailer_data[64];
+	unsigned char trailer_data[64];
 } *cur_salt;
 
 static void init(struct fmt_main *self)
@@ -145,6 +145,10 @@ static int valid(char *ciphertext, struct fmt_main *self)
 	if (!ishex(p))
 		goto err;
 
+	if (((atoi16[ARCH_INDEX(p[6])]<<4)|atoi16[ARCH_INDEX(p[7])]) >
+		sizeof(cur_salt->vsp.domain_name))
+		goto err;
+
 	if ((p = strtokm(NULL, "$")) == NULL)  /* hash */
 		goto err;
 	if (strlen(p) != BINARY_SIZE * 2)
